unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus, WinSock;

type
  TMainForm = class(TForm)
    ListView1: TListView;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Panel2: TPanel;
    Label1: TLabel;
    ServerNameLab: TLabel;
    Label3: TLabel;
    ServerAddLab: TLabel;
    Label5: TLabel;
    ServerPortLab: TLabel;
    ListPopup: TPopupMenu;
    CloseWindow1: TMenuItem;
    KillProcess1: TMenuItem;
    Refresh1: TMenuItem;
    N1: TMenuItem;
    procedure RefreshButClick(Sender: TObject);
    procedure KillButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
  private
    { Private declarations }
  public
    { Public declarations }
    LisSock    : TSocket;
    procedure  InitServer;
  end;

var
  MainForm: TMainForm;

implementation

uses SockUtil, Listen;

{$R *.DFM}

function EnumWinProc(Handle: THandle; LParam: integer): boolean; stdcall;
var
   f   : TMainForm;
   li  : TListItem;
   buf : array[0..MAX_PATH] of char;
   pid : integer;
   hp  : THandle;
   pc  : integer;
begin
   Result := True;
   f := TMainForm(LParam);
   GetWindowText(Handle, buf, sizeof(buf));

   if Length(buf)=0 then exit;

   li := f.ListView1.Items.Add;
   li.Caption := Format('%8.8x', [Handle]);

   li.SubItems.Add(buf);

   GetWindowThreadProcessId(Handle, @pid);
   li.SubItems.Add(Format('%8.8x', [pid]));
   li.Data := pointer(pid);

   hp := OpenProcess(PROCESS_ALL_ACCESS, False, pid);
   pc := GetPriorityClass(hp);
   li.SubItems.Add(Format('%d', [pc]));
   CloseHandle(hp);
end;


procedure TMainForm.RefreshButClick(Sender: TObject);
begin
   ListView1.Items.Clear;
   EnumWindows(@EnumWinProc, integer(Self));
end;

procedure TMainForm.KillButClick(Sender: TObject);
var
   pid : integer;
   hp  : THandle;
begin
   pid := integer(ListView1.Selected.Data);

   hp := OpenProcess(PROCESS_ALL_ACCESS, False, pid);
   TerminateProcess(hp, 1);
   CloseHandle(hp);
end;

procedure TMainForm.CloseButClick(Sender: TObject);
var
   wh  : THandle;
begin
   wh := StrToInt('$'+ListView1.Selected.Caption);
   SendMessage(wh, WM_CLOSE, 0, 0);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
   Timer1.Enabled := False;
   InitServer;
   RefreshButClick(nil);
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
   Close;
end;

procedure TMainForm.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
   li : TListItem;
begin
   li := ListView1.Selected;
   KillProcess1.Enabled := li <> nil;
   CloseWindow1.Enabled := li <> nil;
end;

procedure TMainForm.InitServer;
const
   PORT = 99;
var
   s1, s2   : string;
   lt       : TListenThread;
begin
   StartListenSocket(PORT, LisSock, s1, s2);
   ServerNameLab.Caption := s1;
   ServerAddLab.Caption := s2;
   ServerPortLab.Caption := IntToStr(PORT);

   lt := TListenThread.Create(True);
   lt.LisSock := LisSock;
   lt.Resume;
end;

end.
